.586p
.model flat, stdcall
option casemap:none

; 
.nolist
include	usewdm.inc
includelib	wdm.lib
.list
include	ioctlcodes.inc

; --------------------------------------------------------------------------------------
; 
.data

;  
; <...>

;   NT
wsNtDeviceName  dw '\','D','e','v','i','c','e','\','L','p','t','A','c','c','e','s','s','A','g','e','n','t',0

;  
wsWin32DeviceName dw '\','D','o','s','D','e','v','i','c','e','s','\','L','p','t','A','c','c','e','s','s','A','g','e','n','t',0

NtDeviceName		UNICODE_STRING	{0,0,0}
Win32DeviceName	UNICODE_STRING	{0,0,0}

;   device object
DeviceObject PDEVICE_OBJECT 0

; --------------------------------------------------------------------------------------
; 
.code

; --------------------------------------------------------------------------------------
;     
; --------------------------------------------------------------------------------------
DriverEntry proc near public, DriverObject:PDRIVER_OBJECT, RegistryPath:PUNICODE_STRING
	LOCAL		Status:DWORD
	mov Status,STATUS_SUCCESS	;  

	;        
	invoke RtlInitUnicodeString, offset NtDeviceName, offset wsNtDeviceName
	invoke RtlInitUnicodeString, offset Win32DeviceName, offset wsWin32DeviceName

	push ebx ;   WDM     ebx,       .
	mov ebx,DriverObject
	mov (DRIVER_OBJECT ptr [ebx]).DriverUnload, offset OnUnload
	mov eax, offset OnDispatch
	mov (DRIVER_OBJECT ptr [ebx]).MajorFunction[IRP_MJ_CREATE * (TYPE PDRIVER_DISPATCH)],eax
	mov (DRIVER_OBJECT ptr [ebx]).MajorFunction[IRP_MJ_CLOSE * (TYPE PDRIVER_DISPATCH)],eax
	mov (DRIVER_OBJECT ptr [ebx]).MajorFunction[IRP_MJ_DEVICE_CONTROL * (TYPE PDRIVER_DISPATCH)],eax
	pop ebx

	;    
	invoke IoCreateDevice, DriverObject, 0, offset NtDeviceName, FILE_DEVICE_UNKNOWN,0,FALSE,offset DeviceObject;
	cmp eax,STATUS_SUCCESS	; ,    .
	jnz @F
	
	;  symbolic link
	invoke IoCreateSymbolicLink, offset Win32DeviceName, offset NtDeviceName	;  eax   
 @@:
	ret
DriverEntry endp

; --------------------------------------------------------------------------------------
;    
; --------------------------------------------------------------------------------------
OnUnload proc near, DriverObject:PDRIVER_OBJECT
	;   
	invoke IoDeleteSymbolicLink, offset Win32DeviceName

	;   
	invoke IoDeleteDevice, DeviceObject

	;   
	invoke RtlFreeUnicodeString,offset NtDeviceName
	invoke RtlFreeUnicodeString,offset Win32DeviceName

	ret
OnUnload endp

; --------------------------------------------------------------------------------------
;    device IO control
; Re:    eax   
; --------------------------------------------------------------------------------------
DeviceIoControlHandler proc near, Code:ULONG, pBuffer:PCHAR, InputBufferLength:ULONG, OutputBufferLength:ULONG, pOutputLength:PULONG
	LOCAL	store_count:DWORD
	LOCAL	data_ptr:PUCHAR
	LOCAL	data:UCHAR
	LOCAL	adr:PUCHAR

	mov eax,Code		; . ,      .
	cmp eax,IOCTL_READ_PORTS	;   LPT-
	jz	loc_read_port
	cmp eax,IOCTL_WRITE_PORTS	;    LPT-
	jz	loc_write_port
	mov eax,STATUS_NOT_IMPLEMENTED	;   
	ret

	;     LPT
loc_read_port:
	mov eax,InputBufferLength	;        
	cmp eax,OutputBufferLength
	jnz loc_fault_ioctl

	and eax,0FFFEH	; ׸   -
	mov store_count,eax
	cmp eax,0	;  
	jz  loc_fault_ioctl

	mov eax,pBuffer
	mov data_ptr,eax

 in_loop:			;   
	push ebx
	push edx
	mov ebx,data_ptr
	xor eax,eax
	mov al,BYTE ptr [ebx]	;   --     
	inc ebx
	mov data_ptr,ebx
	mov ah,al
	shr al,1
	shr al,1
	shr al,1
	shr al,1	; al --   LPT -- 1,2  3
	and al,3
	mov edx,3BCH	; LPT1
	cmp al,1
	jz @F
	mov edx,378H	; LPT2
	cmp al,2
	jz @F
	mov edx,278H	; LPT3
 @@:
	mov al,ah
	mov ah,0
	and al,7	;   LPT -- 0..7
	add edx,eax	;   +  
	mov adr,edx
	pop edx
	pop ebx

	invoke READ_PORT_UCHAR, adr	;  

	push ebx
	mov ebx,data_ptr
	mov BYTE ptr [ebx],al	;     
	inc ebx
	mov data_ptr,ebx
	pop ebx

	mov eax,store_count	;   
	sub eax,2
	mov store_count,eax
	cmp eax,0
	jnz in_loop		;      -- .

	push ebx
	mov eax,OutputBufferLength
	mov ebx,pOutputLength	;  ,    .
	mov DWORD ptr [ebx],eax
	pop ebx

	mov eax,STATUS_SUCCESS
	ret

	;     LPT
loc_write_port:
	mov eax,InputBufferLength
	and eax,0FFFEH	; ׸   -
	mov store_count,eax
	cmp eax,0	;  !!!
	jz  loc_fault_ioctl

	mov eax,pBuffer
	mov data_ptr,eax

 out_loop:			;   
	push ebx
	push edx
	mov ebx,data_ptr
	xor eax,eax
	mov al,BYTE ptr [ebx]	;   --     
	inc ebx

	mov ah,al
	shr al,1
	shr al,1
	shr al,1
	shr al,1	; al --   LPT -- 1,2  3; 
	and al,3
	mov edx,3BCH	; LPT1
	cmp al,1
	jz @F
	mov edx,378H	; LPT2
	cmp al,2
	jz @F
	mov edx,278H	; LPT3
 @@:
	mov al,ah
	mov ah,0
	and al,7	;   LPT -- 0..7
	add edx,eax	;   +  
	mov adr,edx
	
	mov al,BYTE ptr [ebx]	;  
	mov data,al
	inc ebx
	mov data_ptr,ebx

	pop edx
	pop ebx

	invoke WRITE_PORT_UCHAR, adr, data	;   

	mov eax,store_count	;   
	sub eax,2
	mov store_count,eax
	cmp eax,0
	jnz out_loop		;      -- .

	mov eax,STATUS_SUCCESS
	ret

loc_fault_ioctl:
	mov eax,STATUS_UNSUCCESSFULL
	ret
DeviceIoControlHandler endp

; <...>

; --------------------------------------------------------------------------------------
;   IRP_MJ_XXX
; --------------------------------------------------------------------------------------
OnDispatch proc near, pDeviceObject:PDEVICE_OBJECT,pIrp:PIRP
	LOCAL Status:DWORD		;     
	LOCAL pIrpStack:DWORD	;    IO_STACK_LOCATION

	LOCAL Code			;    DeviceIoControl
	LOCAL InputBufferLength	;    
	LOCAL OutputBufferLength	;    
	LOCAL pBuffer			;    

	mov Status,STATUS_UNSUCCESSFULL

	push ebx
	mov ebx,pIrp
	mov eax,(_IRP ptr [ebx]).Tail.Overlay.CurrentStackLocation	;     IO_STACK_LOCATION
	mov pIrpStack,eax

	mov ebx,pIrpStack
	mov al,(IO_STACK_LOCATION ptr [ebx]).MajorFunction	;  
	pop ebx

	cmp al,IRP_MJ_CREATE
	jnz @F
	; IRP_MJ_CREATE -- CreateFile()...
	mov Status,STATUS_SUCCESS	;
	jmp OnDispatchLeave

 @@:	cmp al,IRP_MJ_CLOSE
	jnz @F
	; IRP_MJ_CLOSE -- CloseHandle()...
	mov Status,STATUS_SUCCESS
	jmp OnDispatchLeave

 @@:	cmp al,IRP_MJ_DEVICE_CONTROL
	jnz @F
	; IRP_MJ_DEVICE_CONTROL -- DeviceIoControl()...

	push ebx
	mov ebx,pIrp
		;     
	mov eax,(_IRP ptr [ebx]).AssociatedIrp.SystemBuffer
	mov pBuffer,eax

	mov ebx,pIrpStack	;    . 
				; ,    ,     DeviceIoControlHandler
		;   
	mov eax,(IO_STACK_LOCATION ptr [ebx]).Parameters.DeviceIoControl.IoControlCode
	mov Code,eax
		;    
	mov eax,(IO_STACK_LOCATION ptr [ebx]).Parameters.DeviceIoControl.InputBufferLength
	mov InputBufferLength,eax
		;    
	mov eax,(IO_STACK_LOCATION ptr [ebx]).Parameters.DeviceIoControl.OutputBufferLength
	mov OutputBufferLength,eax
	mov ebx,pIrp

	xor eax,eax					;    
	mov (_IRP ptr [ebx]).IoStatus.Information,eax
	mov eax,ebx					;      Information     
	add eax,offset _IRP.IoStatus.Information
	pop ebx
		;  .	
	invoke DeviceIoControlHandler, Code, pBuffer, InputBufferLength, OutputBufferLength, eax
	mov Status,eax	;   
	
	jmp OnDispatchLeave
 @@:	; default
	mov Status,STATUS_NOT_IMPLEMENTED

 OnDispatchLeave:

	mov ecx,pIrp	;   -     
	mov edx,0
	call @IofCompleteRequest@8

	mov eax,Status	;   
	push ebx
	mov ebx,pIrp
	mov (_IRP ptr [ebx]).IoStatus.Status,eax
	pop ebx
	ret
OnDispatch endp

;

end
